Subject: bug#39659: 27.0.60; inappropriate han script definition in char-script-table

From: Eli Zaretskii <[email-masked]>
Date: Sat, 29 Feb 2020 09:34:39 +0200

> From: handa <[email-masked]>
> Cc: [email-masked],  [email-masked]
> Date: Sat, 29 Feb 2020 12:39:30 +0900
> 
> In article <[email-masked]>, [email-masked] writes:
> >>> From: [email-masked]
> >>> Date: Tue, 18 Feb 2020 22:50:57 +0900
> >>> 
> >>> 'han' script is defined in char-script-table as:
> >>> 2E80-2FDF	han
> >>> 3200-9FFF	han
> >>> F900-FAFF	han
> >>> FE30-FE4F	han
> >>> 1F200-1F2FF	han
> >>> 20000-2A6DF	han
> >>> 2A700-2EBEF	han
> >>> 2F800-2FA1F	han
> >>> 
> >>> It is better to set values as:
> >>> 3200-33FF	cjk-misc
> >>> 4DC0-4DFF	cjk-misc
> >>> FE30-FE4F	cjk-misc
> >>> 1F200-1F2FF	cjk-misc
> 
> The script names were at first assigned to help fontset.el which sets up
> the default fontset by using script names in defining font specs (for
> CHARSTE_REGISTRY of X fonts or "script" of OpenType fonts).  So there
> was no precise semantics.

OK, but would you agree that the latter group of character blocks,
i.e.

 3200-33FF
 4DC0-4DFF
 FE30-FE4F
 1F200-1F2FF

should be in the cjk-misc category?  Or, to phrase this differently:
why was cjk-misc created in the first place, since the only difference
between it and han in the default fontset seems to be this single
element:

	  (nil . "JISX0213.2004-1")

which is present for the han script, but absent for cjk-misc.  I don't
think I see where the CHARSET_REGISTRY of X or "script" of OpenType
fonts come into play, when distinguishing between han and cjk-misc
is concerned.

> I think it is ok to change/fix char-script-table to improve some
> behavior of Emacs without breaking fontset.el.

Can you elaborate about this?  I don't think I understand which fixes
you had in mind, and how they could or could not break fontset.el.

Thanks.